module Typecheck where 

import Abssyntax

typeCheckExp :: Exp -> Maybe Type
BExp e o e' = do
	TInt <- typeCheck e
	TInt <- typeCheck e'
	return TBool
OpExp e o e' = do
	TInt <- typeCheck e
	TInt <- typeCheck e'
	return TInt

typeCheckStm :: Stm -> Maybe Type
SNoop = return NoType
SExp e = typeCheckExp e
SBlock ss = do 
	mapM typeCheckStm ss
	return NoType
SIf e s s' = do
	TBool <- typeCheckExp e
	NoType <- typeCheckStm s
	NoType <- typeCheckStm s
	return NoType
SWhile e s = do
	TBool <- typeCheckExp e
	NoType <- typeCheckStm s

